(defun time-it (function &rest args)
  "find the elapsed time time of evaluating a function"
  (let*
      ((time1 nil)
       (result nil)
       (time2 nil)
       (difference))
    (setq time1 (current-time))
    (setq result (apply function args))
    (setq time2 (current-time))
    (setq difference 
          ( + 
            (* (- (nth 0 time2) (nth 0 time1)) (expt 2.0 16))
            (- (nth 1 time2) (nth 1 time1))
            (/ (- (nth 2 time2) (nth 2 time1)) 1000000.0)))
    (cons difference result)))

(defmacro time-expression (expr)
  `(time-it (lambda () ,expr)))

